<?php
namespace Pinpoint\Conesso\Model\Api\Management\Products;

use Magento\Store\Model\StoreManagerInterface;
use Pinpoint\Conesso\Api\Data\ProductSyncInterface;
use Pinpoint\Conesso\Api\Data\ProductSyncInterfaceFactory;
use Pinpoint\Conesso\Api\Repository\ProductsSyncRepositoryInterface;

class LogProduct implements LogProductInterface
{
    private $productSyncFactory;

    private $syncProductRepository;

    private $storeManager;
    public function __construct(
        ProductsSyncRepositoryInterface $syncProductRepository,
        ProductSyncInterfaceFactory $productSyncFactory,
        StoreManagerInterface $storeManager
    ) {
        $this->syncProductRepository = $syncProductRepository;
        $this->productSyncFactory = $productSyncFactory;
        $this->storeManager = $storeManager;
    }

    public function logProduct(\Magento\Catalog\Api\Data\ProductInterface $product, $eventType)
    {
        $productData = $this->productSyncFactory->create();
        $data = [
            ProductSyncInterface::STORE_ID => (int) $this->storeManager->getStore()->getStoreId(),
            ProductSyncInterface::PRODUCT_SKU =>  $product->getSku(),
            ProductSyncInterface::EVENT_TYPE => $eventType,
            ProductSyncInterface::IS_SYNCED => 0,

        ];
        $productData->setData($data);
        $this->syncProductRepository->save($productData);
    }
}
