<?php
namespace Pinpoint\Conesso\Model\Api\Transfer\Request;

use Pinpoint\Conesso\Api\Transfer\RequestInterface;
use Pinpoint\Conesso\Model\Api\Access\Auth;

abstract class AbstractRequest implements RequestInterface
{
    protected $authorization;
    public function __construct(
        Auth $authorization
    ) {
        $this->authorization = $authorization;
    }
    abstract public function buildData(mixed $item);
    abstract public function sendRequest(mixed $data) : bool;

    protected function getConnessoClient()
    {
        return $this->authorization->getConnessoClient();
    }

}

