<?php
namespace Pinpoint\Conesso\Observer\Product;

use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;
use Pinpoint\Conesso\Api\Data\ProductSyncInterface;
use Pinpoint\Conesso\Model\Api\Management\Products\LogProductInterface;
use Psr\Log\LoggerInterface;

class ProductSaveAfter implements ObserverInterface
{
    private $logProduct;
    private $logger;
    public function __construct(
        LogProductInterface $logProduct,
        LoggerInterface $logger
    ) {
        $this->logger = $logger;
        $this->logProduct = $logProduct;
    }

    public function execute(Observer $observer)
    {
        try {
            $product = $observer->getProduct();
            $this->logProduct->logProduct($product,ProductSyncInterface::EVENT_TYPE_SAVE);
        } catch (\Exception $e) {
            $this->logger->info(__($e->getMessage()));
        }
    }
}
