<?php
/**
 * Copyright ©  All rights reserved.
 * See COPYING.txt for license details.
 */
declare(strict_types=1);

namespace Pinpoint\Conesso\Plugin\Webapi\Magento\Customer\Model;

use Magento\Checkout\Model\Session;

class AccountManagement
{
    /**
     * @param Session $checkoutSession
     */
    public function __construct(private readonly Session $checkoutSession) {}

    /**
     * @param \Magento\Customer\Model\AccountManagement $subject
     * @param $result
     * @param $customerEmail
     * @param $websiteId
     * @return mixed
     */
    public function afterIsEmailAvailable(
        \Magento\Customer\Model\AccountManagement $subject,
                                                  $result,
                                                  $customerEmail,
                                                  $websiteId = null
    ) {
        try {
            $quote = $this->checkoutSession->getQuote();
            if (!$quote->getCustomerEmail()) {
                $quote->setCustomerEmail($customerEmail);
                $quote->save();
            }
        } catch (\Exception $e) {
            // do nothing
        }

        return $result;
    }
}
